﻿(function(Otime){

	Otime.Notify	= new function Notify(){
//		"use strict";

		var _this	= this;

		_this.name	= "notify";

		_this.model	= "NotifyModel";

		_this.language	= null;

//		var formatDate	= function(dt){
//			return Otime.stoj(dt).format(Otime.dateFormat + " OO:NN:SS");
//		};

		var tmpl	= '<li class="lsn ${type.toLowerCase()}{{if is_read}} readed{{/if}}" nid="${notification_id}">';
			tmpl	+= '<div class="lpanel"><span class="media-object img20x20"></span></div>';
			tmpl	+= '<div class="rpanel">';
			tmpl	+= '<p class="message"><span class="highlight">${message.comment}</span> ${suffix_msg}</p>';
			tmpl	+= '<p class="time">${updated_date_disp}</p>';
			tmpl	+= '</div></li>';

		var tmplName	= "notificationListTmpl";

		$.template(tmplName, tmpl);

		var notification_types	= {
			TA: function(item){
				// New task Assigned
				item.suffix_msg	= "task assigned to you.";

				return $.tmpl(tmplName, item);
			},
			CO: function(item){
				// Task comment posted
				item.suffix_msg	= "has " + item.count + " unread comments.";

				return $.tmpl(tmplName, item);
			},
			AT: function(item){
				// Attachment added
				item.suffix_msg	= "has " + item.count + " new attachments.";

				return $.tmpl(tmplName, item);
			},
			TU: function(item){
				// Task fields updated
				item.suffix_msg	= "has " + item.count + " updates.";

				return $.tmpl(tmplName, item);
			}/*,
			TD: function(item){
				// Task date changed.
			},
			TT: function(item){
				// Timesheet toggle
			},
			TP: function(item){
				// Task priority updated
			},
			TS: function(item){
				// Task status changed
			}*/
		};

		var readedFlag	= false;
		_this.setAsRead	= function(notification_id, target){
			if (!notification_id)
			{
				return false;
			}

			var url	= Otime.siteUrl + "/notify/readed/" + notification_id;
			Otime.app.postData(new Otime.ContextModel(url, null, function(cont){
				if (cont.response)
				{
					readedFlag	= target;
				}
			}), true);
		};

		_this.last_modified	= null;
		_this.newCount	= function(items){
			var html	= '';
			if (items && items.otvalues && Object.keys(items.otvalues).length > 0)
			{
				items	= items.otvalues.setKeys(items.otkeys, function(item){
					item.message	= JSON.parse(item.message);

					item.is_read	= !!(item.is_read-0);
					item.updated_date	= Otime.stoj(item.updated_date);
					item.updated_date_disp	= item.updated_date.format("MMM DD, OO:NN AP");

					if (!_this.last_modified)
					{
						_this.last_modified	= item.updated_date;
					}
					else if(_this.last_modified < item.updated_date)
					{
						_this.last_modified	= item.updated_date;
					}

					var fn = notification_types[item.type];
					if (typeof fn === "function")
					{
						fn(item).prependTo("#notify-list");
						html	= true;
					}
				});
			}

			$("#notify-list").slimscroll({
				maxHeight: '300px',
				railVisible: true
//				alwaysVisible: true
			});
			!_this.last_modified && $("#notify")[html ? "show" : "hide"]();

			var elem	= $("#notify-list li").not(".readed");
			var cnt	= $("#notify .count");
			if (elem && elem.length)
			{
				cnt.html(elem.length).show();
			}
			else
			{
				cnt.hide();
			}
			
/*
			$("#notify-list").unbind("click").click(function(e){
				var target = $(e.target);
				if (!target.is(".lsn"))
				{
					target = target.parents(".lsn");
				}
				_this.setAsRead(target.attr("nid"), target);
			});
*/
		};

		_this.init	= function(){
			var isOpened	= false;
			$("#notify").click(function(){
				if (isOpened)
				{
					if (readedFlag && readedFlag.length)
					{
						readedFlag.addClass("readed");
						readedFlag	= false;
					}
					isOpened	= false;
				}
				else
				{
					isOpened	= true;
					var elem	= $("#notify-list li").not(".readed");
					if (elem.length)
					{
						_this.setAsRead("all", elem);
						// _this.setAsRead(target.attr("nid"), target);
					}
				}
				$("#notify-cont").toggle();
			});
		};
	};
}(window.Otime));
